/*-
 * Copyright (c) 2002    Granch Ltd. 	All rights reserved.
 *
 * All or some portions of this file are derived from material licensed
 * to the Grahcn Ltd. and are reproduced herein with the permission of
 * Granch Ltd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE GRANCH LTD. AND THEIR CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Author : Rashid N. Achilov 		E-Mail shelton@sentry.granch.ru
 *
 *	$Id: externals.h,v 0.95 2005/10/04 12:11:54 shelton Exp $
 */
/*--------------------------------------------------------------------------

            Spam Control and Canceling mail filter, based on libmilter API

	    UNIX FreeBSD 5.4 version

            Common external variables.

--------------------------------------------------------------------------*/
#ifndef _EXTERNALS_H_
#define _EXTERNALS_H_

#include <includes.h>

extern char *progname;			 // Program file name
extern struct local_flags _flags;	 // Global (all milter) flags
extern struct scchost *scchosts;	 // SCC hosts parsed-down file
extern struct sccuser *sccusers;	 // SCC users parsed-down file
extern short int qscchosts;	  	 // Quantity of SCC hosts
extern short int qsccusers;	  	 // Quantity of SCC users;
extern short int sccerror;		 // Spam and enterprise reason

extern char *cannot; 			 // Part of error messages

extern char *action[];			 // Current action with message

extern const char *html_modes[];	 // HTML isolation modes
extern const char *act_modes[];		 // Processing modes

extern struct local_config _SCC_milter_config;	 // Parsed configuration file

// Debug levels in text array
#ifdef DBPRINT
extern char *dblev[];

// Descriptions of stop chars
extern char *cnstop[];
#endif

// End-of-lines array
extern char nstop[];

extern struct smfiDesc sccfilter;	 // Main data callbacks structure

#endif
