/*-
 * Copyright (c) 2002    Granch Ltd. 	All rights reserved.
 *
 * All or some portions of this file are derived from material licensed
 * to the Grahcn Ltd. and are reproduced herein with the permission of
 * Granch Ltd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE GRANCH LTD. AND THEIR CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Author : Rashid N. Achilov 		E-Mail shelton@sentry.granch.ru
 *
 *	$Id: functions.h,v 0.95.2.1 2005/10/06 07:08:22 shelton Exp $
 */
/*--------------------------------------------------------------------------

            Spam Control and Canceling mail filter, based on libmilter API

	    UNIX FreeBSD 5.4 version

            Common functions description.

--------------------------------------------------------------------------*/
void _SCC_milter_usage (void);			// Print filter usage
void _SCC_milter_daemon_mode(void);		// Go to daemon mode
void _SCC_milter_close(int exitcode);		// Safe exit from filter
void _SCC_milter_parse_commandline(int argc, char *argv[]);

int _SCC_milter_check_charset(SMFICTX *ctx,char *charset);
int _SCC_milter_check_content_type(SMFICTX *ctx,char *line,size_t bodylen,char where);
int _SCC_milter_parse_content_type(SMFICTX *ctx,char header,char *source);

short int _SCC_milter_create_temp_file(char *filename, FILE **filedesc);

struct scchost *_SCC_milter_parse_hosts_file(char *filename, u_short *qrecs);
struct sccuser *_SCC_milter_parse_users_file(char *filename,u_short *qrecs);

int _SCC_milter_recite_message(SMFICTX *ctx);
int _SCC_milter_check_directory(char *pathname);

						// Milter catch-ups
sfsistat mlfi_connect(SMFICTX *ctx, char *hostname, _SOCK_ADDR *hostaddr);
sfsistat mlfi_helo( SMFICTX *ctx, char *helohost);
sfsistat mlfi_envfrom(SMFICTX *ctx, char **argv);
sfsistat mlfi_envrcpt(SMFICTX *ctx, char **argv);
sfsistat mlfi_header(SMFICTX *ctx, char *headerf, char *headerv);
sfsistat mlfi_eoh(SMFICTX *ctx);
sfsistat mlfi_body(SMFICTX *ctx, unsigned char *bodyp, size_t bodylen);
sfsistat mlfi_eom(SMFICTX *ctx);
sfsistat mlfi_abort(SMFICTX *ctx);
sfsistat mlfi_cleanup(SMFICTX *ctx, char recite);
sfsistat mlfi_close(SMFICTX *ctx);
sfsistat _SCC_milter_status_check(SMFICTX *ctx, short int sccerror);
