/*-
 * Copyright (c) 2002    Granch Ltd. 	All rights reserved.
 *
 * All or some portions of this file are derived from material licensed
 * to the Grahcn Ltd. and are reproduced herein with the permission of
 * Granch Ltd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE GRANCH LTD. AND THEIR CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Author : Rashid N. Achilov		E-Mail shelton@sentry.granch.ru
 *
 *	$Id: globals.c,v 0.95 2005/10/04 12:11:54 shelton Exp $
 */
/*-------------------------------------------------------------------------

            Spam Control and Canceling mail filter, based on libmilter API

	    UNIX FreeBSD 5.4 version

            Global variables description.

-------------------------------------------------------------------------*/
#include "sccmilter.h"
#include "includes.h"
#include "functions.h"

char *progname = NULL;			 // Program file name
struct local_flags _flags;		 // Global (all milters) flags
struct scchost *scchosts;		 // SCC hosts parsed-down file
struct sccuser *sccusers;		 // SCC users parsed-down file
short int qscchosts;			 // Quantity of SCC hosts
short int qsccusers;			 // Quantity of SCC users;
short int sccerror;			 // Spam/enterprise reason

char *cannot = "cannot allocate memory to"; // Part of error messages

// Message to construct debug messaages

char *action[HACTIONS] = { "discard", "reject", "isolate" };

const char *html_modes[HMODES] = { "no", "incoming", "outgoing", "full", NULL };

// So, "none" has code 0x0, "discard" - 0x1, "reject" - 0x2,
// "error" - 0x3 (0011 is declined condition now!), "isolate" - 0x4
const char *act_modes[HMODES] = { "none", "discard", "reject",
						"error", "isolate", NULL };

struct local_config _SCC_milter_config;	 // Parsed configuration file

#ifdef DBPRINT
// Debug levels to display in debug messages
char *dblev[5] = { "[20]", "[50]", "[100]", "[110]", "[120]" };

// Descriptions of stop-chars
char *cnstop[NSTOPS] = { "null", "';'", "newline" };
#endif

// End-of-line separators
char nstop[NSTOPS] = {'\0', ';', '\n'};

// Main filter data structure

struct smfiDesc sccfilter =
{
    "sccmilter", 		// filter name
    SMFI_VERSION,   		// version code -- do not change
    SMFIF_ADDHDRS,  		// flags
    mlfi_connect,   		// connection info filter
    mlfi_helo,      		// SMTP HELO command filter
    mlfi_envfrom,   		// envelope sender filter
    mlfi_envrcpt,   		// envelope recipient filter
    mlfi_header,    		// header filter
    mlfi_eoh,       		// end of header
    mlfi_body,      		// body block filter
    mlfi_eom,       		// end of message
    mlfi_abort,     		// message aborted
    mlfi_close,     		// connection cleanup
};

