/*-
 * Copyright (c) 2002    Granch Ltd. 	All rights reserved.
 *
 * All or some portions of this file are derived from material licensed
 * to the Grahcn Ltd. and are reproduced herein with the permission of
 * Granch Ltd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE GRANCH LTD. AND THEIR CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Author : Rashid N. Achilov		E-Mail shelton@sentry.granch.ru
 *
 *	$Id: includes.h,v 0.94 2005/10/04 12:11:54 shelton Exp $
 */
/*-------------------------------------------------------------------------

            Spam Control and Canceling mail filter, based on libmilter API

	    UNIX FreeBSD 5.4 version

            Included headers.

-------------------------------------------------------------------------*/
#include <config.h>

#ifdef HAVE_SYS_TYPES_H
 #include <sys/types.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
 #include <sys/socket.h>
#endif

#ifdef HAVE_NETINET_IN_H
 #include <netinet/in.h>
#endif

#ifdef HAVE_ARPA_INET_H
 #include <arpa/inet.h>
#endif

#ifdef HAVE_STDIO_H
 #include <stdio.h>
#endif

#ifdef HAVE_CTYPE_H
 #include <ctype.h>
#endif

#ifdef STDC_HEADERS
 #include <stdlib.h>
 #include <string.h>
#endif

#ifdef HAVE_SIGNAL_H
 #include <signal.h>
#endif

#ifdef HAVE_LIMITS_H
 #include <limits.h>
#endif

#ifdef HAVE_SYS_STAT_H
 #include <sys/stat.h>
#endif

#ifdef HAVE_SYS_PARAM_H
 #include <sys/param.h>
#endif

#ifdef HAVE_SYSEXITS_H
 #include <sysexits.h>
#endif

#ifdef HAVE_UNISTD_H
 #include <unistd.h>
#endif

#ifdef HAVE_SYSLOG_H
 #include <syslog.h>
#endif

#ifdef TIME_WITH_SYS_TIME
 #include <sys/time.h>
 #include <time.h>
#else
 #ifdef HAVE_SYS_TIME_H
  #include <sys/time.h>
 #else
  #include <time.h>
 #endif
#endif

#ifdef HAVE_LIBMILTER_MFAPI_H
 #include <libmilter/mfapi.h>
#endif

#ifdef HAVE_SYS_UN_H
 #include <sys/un.h>
#endif

#ifdef HAVE_GETOPT_H
 #include <getopt.h>
#endif

#ifdef HAVE_ERRNO_H
 #include <errno.h>
#endif

#ifdef HAVE_FCNTL_H
 #include <fcntl.h>
#endif

#ifdef HAVE_NETDB_H
 #include <netdb.h>
#endif

#ifdef HAVE_PARSECONFIG_H
 #include <parseconfig.h>
#endif

#ifdef HAVE_LIBCONF_H
 #include <libconf.h>
#endif

#ifdef HAVE_LOCALTYPES_H
 #include <localtypes.h>
#endif

#ifdef HAVE_SCCERROR_H
 #include <sccerror.h>
#endif

