/*-
 * Copyright (c) 2005  Granch Ltd. 	All rigts reserved.
 *
 * All or some portions of this file are derived from material licensed
 * to the Grahcn Ltd. and are reproduced herein with the permission of
 * Granch Ltd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE GRANCH LTD. AND THEIR CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Author : Rashid N. Achilov		E-Mail shelton@granch.ru
 *
 *	$Id: checklist.c,v 1.2 2005/10/04 12:11:54 shelton Exp $
 */
/*-------------------------------------------------------------------------

            Standard functions library

	    Parsing of "standard list" parameter, which can contain only
            a predefined list of strings. Value of "binopt" was set to
            number of option, found in list (i.e. in list is "aaa", "bbb",
            "ccc", option is "bbb", binopt will set to 1. "list" MUST included
            last element with NULL pointer!

            FreeBSD 5.4 version

            Call: int _checklist(char *option, char *binopt, char *list[]);

            Return:  1 - option was found in list
            	     0 - option was not found in list or parsing error

-------------------------------------------------------------------------*/
#include "make.h"

int _checklist(char *option, char *binopt, char **list)
{
  short int lind;

// Clean probably junk

  *binopt = NO;

// First, check selected mode on presence

  if (*option == '\0')
    return NO;

// First, we search what type of isolation/prodessing we have specified...

  for(lind = 0;*(list + lind) != NULL;lind++)
   if (!(strcmp(option,*(list + lind))))
     break;

// When all types were scanned, but none match - we encountered an error
// Also we mark as error, when this place was occupied "error" string
// Else we storing calculated lind as mode

  if ((*(list + lind) == NULL) ||
  	(!strcasecmp(*(list + lind),"error")))
    return ERR;
   else
     *binopt = lind;

  return OK;
}
