//
// This part of library hav been downloaded somewhere from Internet. So, it
// hasn't License Agreement. I don't need somebody's honor.
// $Id: decodebase64.c,v 0.94 2005/10/04 12:11:54 shelton Exp $
//
/*------------------------------------------------------------------------

            Standard functions library

            Decoding array, which has been coded by Base64

            FreeBSD 5.4 version

            Call: int decode_base64(char *src, char *dest, int sizedest);
            Return: <int> - bytes decoded, all OK
                    -1	  - some errors have been detected

--------------------------------------------------------------------------*/
#include "make.h"

static const char Base64[] =
	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static const char Pad64 = '=';

int decode_base64(char *src, char *dest, int sizedest)
{
  int destidx, state, ch;
  char *pos;

  state = 0;
  destidx = 0;

  while ((ch = *src++) != '\0')
   {
     if (isspace(ch))	 			// Skip whitespace
       continue;

     if (ch == Pad64)
       break;

     pos = strchr(Base64, ch);
     if (pos == 0) 				// A non-base64 character
       return ERR;

     switch (state)
      {
        case 0: if (dest)
    	          {
    		    if (destidx >= sizedest)
    		      return ERR;

    		    dest[destidx] = (pos - Base64) << 2;
    	          }

    	        state = 1;
    	        break;

        case 1: if (dest)
    	          {
    		    if (destidx + 1 >= sizedest)
    		      return ERR;

    		    dest[destidx]   |=  (pos - Base64) >> 4;
    		    dest[destidx+1]  = ((pos - Base64) & 0x0f) << 4 		;
    	          }

    	        destidx++;
    	        state = 2;
    	        break;

        case 2: if (dest)
    	          {
    		    if (destidx + 1 >= sizedest)
    		      return ERR;

    		    dest[destidx]   |=  (pos - Base64) >> 2;
    		    dest[destidx+1]  = ((pos - Base64) & 0x03) << 6;
    	          }

    	        destidx++;
    	        state = 3;
    	        break;

        case 3: if (dest)
    	          {
    		    if (destidx >= sizedest)
    		      return ERR;

    		    dest[destidx] |= (pos - Base64);
    	          }

    	        destidx++;
    	        state = 0;
    	        break;
      }
   }

  // We are done decoding Base-64 chars.  Let's see if we ended
  //	on a byte boundary, and/or with erroneous trailing characters.

  if (ch == Pad64)			// We got a pad char
    {
      ch = *src++;			// Skip it, get next
      switch (state)
       {
         case 0:			// Invalid = in first position
         case 1: return ERR;		// Invalid = in second position


      	 case 2: 			// Valid, means one byte of info
      					// Skip any number of spaces
      		 for (; ch != '\0'; ch = *src++)
      		  if (!isspace(ch))
      		    break;

      					// Make sure there is another
      					// trailing = sign
      		 if (ch != Pad64)
      		   return ERR;

      		 ch = *src++;		// Skip the =
	      				// Fall through to "single
	      				// trailing =" case
      					// FALLTHROUGH

         case 3: 			// Valid, means two bytes of info
      					// We know this char is an =.
      					// Is there anything but
      					// whitespace after it?
      	         for (; ch != '\0'; ch = *src++)
      		    if (!isspace(ch))
      		      return ERR;

      	// Now make sure for cases 2 and 3 that the "extra"
      	//	bits that slopped past the last full byte were
      	//	zeros.  If we don't check them, they become a
      	//	subliminal channel.
      		 if (dest && dest[destidx] != 0)
      		   return ERR;
       }
    }
   else
     {
  	// We ended by seeing the end of the string.  Make sure we
  	//	have no partial bytes lying around.
       if (state != 0)
  	 return ERR;
     }

  return (destidx);
}
