//
// This part of library hav been downloaded somewhere from Internet. So, it
// hasn't License Agreement. I don't need somebody's honor.
// $Id: encodebase64.c,v 0.94 2005/10/04 12:11:54 shelton Exp $
//
/*------------------------------------------------------------------------

            Standard functions library

            Coding array by Base64 method

            FreeBSD 5.4 version

            Call: int encode_base64(char *src, char *dest,
            				int sizedest,int srclen);
            Return: <int> - bytes coded, all OK
                    -1	  - some errors have been detected

--------------------------------------------------------------------------*/
#include "make.h"

static const char Base64[] =
	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static const char Pad64 = '=';

int encode_base64(char *src, char *dest, int sizedest,int srclen)
{
  char a,b,c,d,*cp,*dst;
  int i,enclen,remlen;
  char *sfrmt = "dst + 6 - dest > sizedest (0x%X + 6 - 0x%X > %d)\n";
  cp = src;
  dst = dest;

  enclen = srclen / 3;			// number of 4 byte encodings
  					// (source DIV 3)
  remlen = srclen - 3 * enclen;		// remainder if srclen not divisible
  					//  by 3 (source MOD 3)

  for (i = 0; i < enclen; i++)
   {
     a = (cp[0] >> 2);
     b = (cp[0] << 4) & 0x30;
     b |= (cp[1] >> 4);
     c = (cp[1] << 2) & 0x3c;
     c |= (cp[2] >> 6);
     d = cp[2] & 0x3f;
     cp += 3;

     if (dst + 6 - dest > sizedest)
       {
         fputs("(full)",stderr);
         fprintf(stderr,sfrmt,(u_int) dst,(u_int) dest,sizedest);
         return ERR;
       }

     sprintf(dst, "%c%c%c%c",*(Base64 + a),
        		*(Base64 + b),*(Base64 + c),*(Base64 + d));
     dst += 4;
   }

  if (remlen == 0)
    return (dst - dest + 1);

  if (remlen == 1)
    {
      a = (cp[0] >> 2);
      b = (cp[0] << 4) & 0x30;

      if (dst + 6 - dest > sizedest)
        {
          fputs("(half)",stderr);
          fprintf(stderr,sfrmt,(u_int) dst,(u_int) dest,sizedest);
          return ERR;
        }

      sprintf(dst, "%c%c==",*(Base64 + a),*(Base64 + b));
      dst += 4;
    }
   else 					// remlen == 2
     {
       a = (cp[0] >> 2);
       b = (cp[0] << 4) & 0x30 ;
       b |= (cp[1] >> 4);
       c = (cp[1] << 2) & 0x3c;

       if (dst + 6 - dest > sizedest)
         {
           fputs("(single)",stderr);
           fprintf(stderr,sfrmt,(u_int) dst,(u_int) dest,sizedest);
           return ERR;
         }

       sprintf(dst, "%c%c%c=",*(Base64 + a),*(Base64 + b),*(Base64 + c));
       dst += 4;
     }

  return dst - dest + 1;
}
