/*-
 * Copyright (c) 2002  Granch Ltd. 	All rigts reserved.
 *
 * All or some portions of this file are derived from material licensed
 * to the Grahcn Ltd. and are reproduced herein with the permission of
 * Granch Ltd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE GRANCH LTD. AND THEIR CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Author : Rashid N. Achilov		E-Mail shelton@granch.ru
 *
 *	$Id: replacestring.c,v 0.94 2005/10/04 12:11:54 shelton Exp $
 */
/*-------------------------------------------------------------------------

            Standard functions library

            Change one text string to another in text buffer

            FreeBSD 5.4 version

            Call: void replacestring(char **src, *char *part1,
            					char *part2, int *ssize);

                        src   - source text buffer address
                        part1 - source string
                        part2 - replacing string
                        ssize - pointer to source size area

            After conversion to ssize pointer will be stored new source
            buffer size.

-------------------------------------------------------------------------*/
#include "make.h"

void replacestring(char **src,char *part1,char *part2,int *ssize)
{
  char *binbuf,*urlget,*isrc;
  int count,osize,degree = NUL,slen1;

  isrc = *src;
  osize = *ssize;

  slen1 = strlen(part1);
  degree = strlen(part2) - slen1;

  if (degree > NUL)
    {
      for(binbuf = isrc,count = 0;binbuf <= (isrc + *ssize);
    				binbuf += ((urlget - binbuf) + slen1))
       if ((urlget = strstr(binbuf,part1)) != NULL)
         count++;
        else
          break;

      osize += (count * degree);
      isrc = (char *) realloc(isrc,osize);
    }

  for(binbuf = isrc;;)
   {
     if (!(urlget = strstr(binbuf,part1)))
       {
         binbuf += strlen(isrc) - (binbuf - isrc);
         *(binbuf) = '\0';
         break;
       }
      else
        memmove(urlget + slen1 + degree,urlget + slen1,
			strlen(isrc) - ((urlget + slen1) - isrc) + 1);

     memmove(urlget,part2,strlen(part2));
     binbuf = isrc + ((urlget - isrc) + slen1 + degree);
   }

  *ssize = binbuf - isrc;
  *src = isrc;

  return;
}
