/*-
 * Copyright (c) 2001 Mike Barcroft <mike@FreeBSD.org>
 * Copyright (c) 1990, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * Chris Torek.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

// This is a slighty modified version of strnstr standard FreeBSD function. The only
// reason to do a modification is an abllity to keep from SIGSEGV, which usually
// trap, when strnstr tries to "look" outside the memory chunk

// We didn't insert our licensing header here. We do not need another glory.
// But, as usual, ABSOLUTELY WITHOUT ANY KIND OF WARRANTIES!!!
// $Id: strnstr.c,v 1.2 2005/03/02 06:59:08 shelton Exp $

#include "make.h"

/*
 * Find the first occurrence of find in s, where the search is limited to the
 * first slen characters of s.
 */
char *
__strnstr(const char *s, const char *find, size_t slen)
{
  char c, sc;
  size_t len;

// When first char of searchable string is zero-pad, return c

  if ((c = *find++) != '\0')
    {

// Take length of searchable string

      len = strlen(find);

      do
       {

// Engine level loop - do while sc != c

	 do
	  {

// Be safe with read outside memoru chunk

	    if (slen-- < 1)
              return NULL;

// Check on zero-pad

	    if ((sc = *s++) == '\0')
	      return (NULL);

	  } while (sc != c);

// When tailored part > len - return NULL

	 if (len > slen)
	   return (NULL);

       } while (strncmp(s, find, len) != 0);

      s--;
    }

  return ((char *)s);
}
