/*-
 * Copyright (c) 2002    Granch Ltd. 	All rights reserved.
 *
 * All or some portions of this file are derived from material licensed
 * to the Grahcn Ltd. and are reproduced herein with the permission of
 * Granch Ltd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE GRANCH LTD. AND THEIR CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Author : Rashid N. Achilov 		E-Mail shelton@sentry.granch.ru
 *
 *	$Id: sccmilter.h,v 0.95.2.1 2005/10/05 05:08:14 shelton Exp $
 */
/*------------------------------------------------------------------------

            Spam Control and Canceling mail filter, based on libmilter API

	    UNIX FreeBSD 5.4 version

            Global definitions.

--------------------------------------------------------------------------*/

// Global definitions
#define OK	1
#define NO	0
#define ERR    -1

#define SCC_MILTER	"Spam control and canceling mail filter, based on Milter API"
#define SCC_DATE	"built on "__DATE__" at "__TIME__ " "

#define MLFIPRIV        ((struct mlfiPriv *) smfi_getpriv(ctx))

// Length of some areas
#define TEMPLENGTH	32		// Length of temp file name
#define WORKLENGTH	128		// Length of work space
#define READLENGTH	80		// Length of read line area

// SMTP error codes
#define SMTPREJECT	"554"		// SMTP reject base code
#define SMTPADDREJECT	"5.7.1"		// SMTP reject extended code

#define RECITE_MESSAGE  1		// Save this message for further
#define PASS_MESSAGE    0		// Simply pass through

// Call point selectors
#define HEADER		1		// Call from mlfi_header()
#define BODY		2		// Call from mlfi_body()
#define CHARSET		3		// Call for parse charset=
#define BOUNDARY	4		// Call for parse boundary=

// Modes to selectors
#define DISCARD		0		// Discard
#define REJECT		1		// Reject
#define ISOLATE		2		// Isolate

// Quantity of stoppers for charset=/boundary= lines
#define NSTOPS		3		// Charset/boundary stoppers

// Quantity of HTML isolation modes
#define HMODES		6		// HTML isolation modes (+1 reserved)
#define HACTIONS	3		// Actions about modes

// Deafult pathways
#ifndef CONFIG
 #define CONFIG			"/usr/local/etc/sccmilter/sccmilter.conf"
#endif

#ifndef ISOLATOR
 #define ISOLATOR		"/var/spool/maildrop/isolated"
#endif

#ifndef EXTRASAVE
 #define EXTRASAVE		"/var/spool/maildrop/extrasave"
#endif

#ifndef SCCUSERS
 #define SCCUSERS		"/usr/local/etc/sccmilter/sccusers"
#endif

#ifndef SCCHOSTS
 #define SCCHOSTS		"/usr/local/etc/sccmilter/scchosts"
#endif

// Default path to isolator and extrasave dirs
#define _DEFAULT_PATH		"/tmp"

// Mandatory variables
#ifndef PKGNAME
 #error PKGNAME variable is mandatory. Check your configure script.
#endif

#ifndef PKGVERSION
 #error PKGVERSION variable is mandatory. Check your configure script.
#endif
